<%
    ssh_config = dispatcher.call_sync('service.sshd.get_config')
%>\
Subsystem sftp /usr/libexec/sftp-server -l ${ssh_config['sftp_log_level']} -f ${ssh_config['sftp_log_facility']}
Protocol 2
UseDNS no
ChallengeResponseAuthentication no
ClientAliveCountMax 3
ClientAliveInterval 15
Port ${ssh_config['port']}
PermitRootLogin ${"yes" if ssh_config['permit_root_login'] else "without-password"}
AllowTcpForwarding ${"yes" if ssh_config['allow_port_forwarding'] else "no"}
Compression ${"delayed" if ssh_config['compression'] else "no"}
PasswordAuthentication ${"yes" if ssh_config['allow_password_auth'] else "no"}
PubkeyAuthentication ${"yes" if ssh_config['allow_pubkey_auth'] else "no"}
GSSAPIAuthentication ${"yes" if ssh_config['allow_gssapi_auth'] else "no"}
AuthorizedKeysCommand /usr/local/libexec/authorized-keys-helper
AuthorizedKeysCommandUser root
% if ssh_config['auxiliary']:
${ssh_config['auxiliary']}
% endif
