"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/*
 * Copyright 2015 iXsystems, Inc.
 * All rights reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted providing that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

var StreamClient = exports.StreamClient = function () {
    function StreamClient() {
        _classCallCheck(this, StreamClient);

        this.socket = null;
        this.token = null;
        this.authenticated = false;

        /* Callbacks */
        this.onOpen = function () {};
        this.onClose = function () {};
        this.onData = function () {};
    }

    _createClass(StreamClient, [{
        key: "__onopen",
        value: function __onopen() {
            this.socket.send(JSON.stringify({
                "token": this.token
            }));
        }
    }, {
        key: "__onclose",
        value: function __onclose() {
            this.onClose();
        }
    }, {
        key: "__onmessage",
        value: function __onmessage(msg) {
            var _this = this;

            if (!this.authenticated) {
                var payload = JSON.parse(msg.data);
                if (payload.status == "ok") {
                    this.authenticated = true;
                } else {
                    /* XXX error */
                }

                return;
            }

            var reader = new FileReader();
            reader.onload = function () {
                _this.onData(reader.result);
            };
            reader.readAsBinaryString(msg.data);
        }
    }, {
        key: "connect",
        value: function connect(token, url) {
            this.token = token;
            this.socket = new WebSocket(url);
            this.socket.onopen = this.__onopen.bind(this);
            this.socket.onmessage = this.__onmessage.bind(this);
            this.socket.onclose = this.__onclose.bind(this);
            this.onOpen();
        }
    }, {
        key: "disconnect",
        value: function disconnect() {
            if (this.socket === null) {}

            this.socket.close();
        }
    }, {
        key: "send",
        value: function send(data) {
            this.socket.send(data);
        }
    }]);

    return StreamClient;
}();

var ShellClient = exports.ShellClient = function (_StreamClient) {
    _inherits(ShellClient, _StreamClient);

    function ShellClient(client) {
        _classCallCheck(this, ShellClient);

        var _this2 = _possibleConstructorReturn(this, (ShellClient.__proto__ || Object.getPrototypeOf(ShellClient)).call(this));

        _this2.client = client;
        return _this2;
    }

    _createClass(ShellClient, [{
        key: "connect",
        value: function connect(command) {
            var _this3 = this;

            this.client.call("shell.spawn", [command], function (result) {
                _get(ShellClient.prototype.__proto__ || Object.getPrototypeOf(ShellClient.prototype), "connect", _this3).call(_this3, result, "ws://" + _this3.client.hostname + "/dispatcher/stream");
            });
        }
    }]);

    return ShellClient;
}(StreamClient);

var ContainerConsoleClient = exports.ContainerConsoleClient = function (_ShellClient) {
    _inherits(ContainerConsoleClient, _ShellClient);

    function ContainerConsoleClient(client) {
        _classCallCheck(this, ContainerConsoleClient);

        var _this4 = _possibleConstructorReturn(this, (ContainerConsoleClient.__proto__ || Object.getPrototypeOf(ContainerConsoleClient)).call(this));

        _this4.client = client;
        return _this4;
    }

    _createClass(ContainerConsoleClient, [{
        key: "connect",
        value: function connect(container) {
            var _this5 = this;

            /* Request shell connection */
            this.client.call("containerd.management.request_console", [container], function (result) {
                _get(ContainerConsoleClient.prototype.__proto__ || Object.getPrototypeOf(ContainerConsoleClient.prototype), "connect", _this5).call(_this5, result, "ws://" + _this5.client.hostname + ":5500/console");
            });
        }
    }]);

    return ContainerConsoleClient;
}(ShellClient);